package edu.gmu.trimdroid;

import edu.gmu.trimdroid.alloy.CGToAlloy;
import edu.gmu.trimdroid.alloy.Evaluator;
import edu.gmu.trimdroid.alloy.LayoutToAlloy;
import edu.gmu.trimdroid.soot.callgraph.BehaviorModelExtractor;
import edu.gmu.trimdroid.soot.depextract.DependencyExtractor;
import edu.gmu.trimdroid.soot.utils.Util;
import edu.gmu.trimdroid.testgen.TestCaseGenerator;
import org.xml.sax.SAXException;

import javax.xml.bind.JAXBException;
import javax.xml.parsers.ParserConfigurationException;
import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.List;

public class Main {

//	private static final String APP_NAME = "Tipster";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/Tipster";
//	private static final String R_FILE = TARGET_APP + "/gen/com/examples/tipcalc/R.java";
//	private static final String R_FILE_PACKAGE = "gen.com.examples.tipcalc";

//	private static final String APP_NAME = "TippyTipper";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/TippyTipper";
//	private static final String R_FILE = TARGET_APP + "/gen/net/mandaria/R.java";
//	private static final String R_FILE_PACKAGE = "net.mandaria";
	
//	private static final String APP_NAME = "JustSit";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/JustSit";
//	private static final String R_FILE = TARGET_APP + "/gen/com/brocktice/JustSit/R.java";
//	private static final String R_FILE_PACKAGE = "com.brocktice.JustSit";

//	private static final String APP_NAME = "MunchLife";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/MunchLife";
//	private static final String R_FILE = TARGET_APP + "/gen/info/bpace/munchlife/R.java";	
//	private static final String R_FILE_PACKAGE = "info.bpace.munchlife";

//	private static final String APP_NAME = "DoFCalculator";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/DoFCalculator";
//	private static final String R_FILE = TARGET_APP + "/gen/org/katsarov/dofcalc/R.java";
//	private static final String R_FILE_PACKAGE = "org.katsarov.dofcalc";
	
//	private static final String APP_NAME = "PasswordMakerPro";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/PasswordMakerPro";
//	private static final String R_FILE = TARGET_APP + "/gen/org/passwordmaker/android/R.java";
//	private static final String R_FILE_PACKAGE = "org.passwordmaker.android";
	
//	private static final String APP_NAME = "BlinkenlightsBattery";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/BlinkenlightsBattery";
//	private static final String R_FILE = TARGET_APP + "/gen/ch/blinkenlights/battery/R.java";
//	private static final String R_FILE_PACKAGE = "ch.blinkenlights.battery";
	
//	private static final String APP_NAME = "AnyCut";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/AnyCut";
//	private static final String R_FILE = TARGET_APP + "/gen/com/example/anycut/R.java";
//	private static final String R_FILE_PACKAGE = "com.example.anycut";

//	private static final String APP_NAME = "TokenList";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/AndroidToken";
//	private static final String R_FILE = TARGET_APP + "/gen/uk/co/bitethebullet/android/token/R.java";
//	private static final String R_FILE_PACKAGE = "uk.co.bitethebullet.android.token";
	
//	private static final String APP_NAME = "HashPass";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/HashPass";
//	private static final String R_FILE = TARGET_APP + "/gen/byrne/utilities/hashpass/R.java";
//	private static final String R_FILE_PACKAGE = "byrne.utilities.hashpass";

	private static final String APP_NAME = "Remembeer";
	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/Remembeer";
	private static final String R_FILE = TARGET_APP + "com/wanghaus/remembeer/R.java";
	private static final String R_FILE_PACKAGE = "com.wanghaus.remembeer";
	
//	private static final String APP_NAME = "httpmon";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/httpmon";
//	private static final String R_FILE = TARGET_APP + "/gen/org/jtb/httpmon/R.java";
//	private static final String R_FILE_PACKAGE = "org.jtb.httpmon";

//	private static final String APP_NAME = "Autoanswer";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/Autoanswer";
//	private static final String R_FILE = TARGET_APP + "/gen/com/everysoft/autoanswer/R.java";
//	private static final String R_FILE_PACKAGE = "com.everysoft.autoanswer";

//	private static final String APP_NAME = "DivideAndConquer";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/DivideAndConquer";
//	private static final String R_FILE = TARGET_APP + "com/google/android/divideandconquer/R.java";
//	private static final String R_FILE_PACKAGE = "com.google.android.divideandconquer";
	
//	private static final String APP_NAME = "PasswordHasher";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/AndrominumApps/hashit";
//	private static final String R_FILE = TARGET_APP + "/gen/com/ginkel/hashit/R.java";
//	private static final String R_FILE_PACKAGE = "com.ginkel.hashit";
	
//	private static final String APP_NAME = "MyCustomApp";
//	private static final String TARGET_APP = "/Users/nariman/Dropbox/RealApps/MyCustomApp";
//	private static final String R_FILE = TARGET_APP + "/edu/gmu/android/R.java";
//	private static final String R_FILE_PACKAGE = "edu.gmu.android";

//	private static final String APP_NAME = "GenApp1";
//	private static final String TARGET_APP = "/Users/nariman/Workspace/SIG-GenApps/GenApp1/GenApp1";
//	private static final String R_FILE = TARGET_APP + "/com/example/template/R.java";
//	private static final String R_FILE_PACKAGE = "com.example.template";

	
	private static final String IM_OUTPUT_PATH = "/im/";
	private static final String BM_OUTPUT_PATH = "/bm/";
	private static final String STRINGS_XML = "/res/values/strings.xml";

	public static void main(String args[]) throws IOException, ParserConfigurationException, JAXBException, SAXException, InterruptedException {

		String inputAPK;
		String prunningOption = args[1];
        String srcPath;
        String appName;   
        String appFolder;
        boolean sourceAvailable = false;

        boolean prunning = true;
        
        if (sourceAvailable) {
           	appName = APP_NAME;
           	srcPath = TARGET_APP;
    		inputAPK = TARGET_APP + "/bin/" + APP_NAME + ".apk";
    		appFolder = srcPath;
        } else {
        	appName= args[0];
        	inputAPK = appName + ".apk";
            srcPath = "out/"+appName+"/src";   
            appFolder = "out/"+appName;
        }

        System.out.println(appName);

        
//        if(prunningOption.trim().equals("") || prunningOption.equals("d"))
//            prunning = false;
//        else 
//        	prunning = true;

		DependencyExtractor dependencyExtractor = new DependencyExtractor(inputAPK);

        for(List<String> l:dependencyExtractor.getHandlerDependecies())
            for(String s:l) {
                System.out.println(s);
            }

		
		// Generate formal Interface Model from Layout files
		new LayoutToAlloy(appFolder, "out/"+appName+IM_OUTPUT_PATH, appFolder+STRINGS_XML, dependencyExtractor, prunning);
		
		// TODO: BM exists do not generate
        new BehaviorModelExtractor(inputAPK,appFolder,"out/"+appName+"/atm/","atm");

		// Generate formal Behavior Model from app's Call Graph		
		new CGToAlloy(appFolder, appName, "out/"+appName+"/atm/atm.xml", "out/"+appName+BM_OUTPUT_PATH);

        // copy interfaceModel.als to target im
        // copy behaviorModel.als to target bm
        Util.copyFile("data/behavioralModel.als","out/" + appName + BM_OUTPUT_PATH+"behavioralModel.als");
        Util.copyFile("data/interfaceModel.als","out/" + appName + IM_OUTPUT_PATH+"interfaceModel.als");


        // Solve IM Models
		new Evaluator("out/"+appName+IM_OUTPUT_PATH);

		// Solve BM Models
		new Evaluator("out/"+appName+BM_OUTPUT_PATH);

		new TestCaseGenerator(appFolder, appName, IM_OUTPUT_PATH+"solutions", BM_OUTPUT_PATH+"solutions"+"/"+appName, dependencyExtractor, sourceAvailable, prunning);
			
		System.out.println("DONE!!!");
	}

}