package edu.gmu.trimdroid.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

/**
 * Created by nariman on 9/17/14.
 */
public class TrimDroidGUI extends JFrame {
    private JTextField textField1;
    private JButton browseButton1;
    private JTextField textField2;
    private JButton browseButton;
    private JRadioButton onRadioButton;
    private JRadioButton offRadioButton;
    private JButton runButton;
    private JFileChooser apkChooser;
    private JFileChooser outPutChooser;
    private File apkPath;
    private File outPutPath;

    public TrimDroidGUI() {
        super("TrimDroid");

        //Create a file chooser
        apkChooser = new JFileChooser();
        outPutChooser = new JFileChooser();
        outPutChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

        browseButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                int returnVal = apkChooser.showOpenDialog(TrimDroidGUI.this);
                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    apkPath = apkChooser.getSelectedFile();
                }
                textField1.setText(apkPath.getPath());
            }
        });

        browseButton1.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                int returnVal = outPutChooser.showOpenDialog(TrimDroidGUI.this);
                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    outPutPath = outPutChooser.getSelectedFile();
                }
                textField2.setText(outPutPath.getPath());
            }
        });
    }

}
